# Perl socket server
# Nothing special. It just gets the job done.

# Import modules...
use IO::Socket;
use IO::Select;

# Setup the 'listener' socket
# It defaults to listening on ALL available IP addresses, but at the port specified (2229).
$manager = new IO::Socket::INET ( Listen => 1, LocalPort => 2229);
# Initialize the new Select object
$selectObj = new IO::Select($manager);
# Set the EOF indicator to the 'null-byte' - as per the Flash instructions.
$/ = "\0";
# Indicate that we're ready.
print "Started\n";

# Loop and deal with connections.
while(@readySockets = $selectObj -> can_read){
	foreach (@readySockets){
		# If the new connection is the 'manager', then it's a 'connection request'
		if($_ == $manager){
			$newConnection = $manager -> accept;
			# Add the new connection to the list of socket handles to 'wait' on
			$selectObj -> add($newConnection);
			# Get the remote IP of the client.
			$clientHost = $newConnection->peerhost;
			# Notify the Client they have been accepted.
			# This is NOT mandatory. Flash will be able to tell on it's own that it is connected.
			# This will not trigger the 'onConnect' event handler for Flashs XMLSocket object. (See previous comment)
			$syswriteToClient = syswrite($newConnection, '<SYS>WELCOME...'.$clientHost.'</SYS>'."\0", 2048);
			print '<SYS>WELCOME...'.$clientHost.'</SYS>'."\0\n";
		}
		else{
			# Read from the new socket... this is dangerous.. kinda... it assumes that there
			# will never be more than 2k sent through the socket... that is over 1500 characters though... : )
			my $sysreadReturn = sysread($_, $infoRead, 2048);
			# if the sysread returns 0 then there's nobody home
			if($sysreadReturn == 0){
				# This makes sure we can't write to them.
				$syswriteToClient = syswrite($_, '<SYSping/>', 2048);
				if($syswriteToClient==undef){
					# notify that the client has disconnected.
					print "Client disconnected.\n";
					# Remove the clients socket handle from the list that we were waiting on.
					$selectObj -> remove($_);
				}
			}
			# if the sysread passes, then the client is still there.
			else{
				# Send what we read to the console.
				print "Read: $infoRead\n";
				# Broadcast what we read to each client as well.
				foreach $eachClient ($selectObj->handles){
					# Again... the 1500 character limit...
					$syswriteToEachClient = syswrite($eachClient, $infoRead, 2048);
				}
			}
		}
	}
}